defmodule TrixtaRolesTest do
  use ExUnit.Case
  doctest TrixtaRoles

  setup do
    id = UUID.uuid1()

    role_plain_map = %{
      "id" => id,
      "name" => "Genèsis Plain",
      "description" => "The Genèsis Plain Role",
      "current_state" => :initialising
    }

    role1_plain_map = %{
      "name" => "Genèsis One Plain",
      "description" => "The Genèsis One Plain Role",
      "current_state" => :initialising
    }

    role = %TrixtaRoles.Role{
      id: id,
      name: "Genèsis",
      description: "The Genèsis Role",
      current_state: :initialising
    }

    role1 = %TrixtaRoles.Role{
      name: "Genèsis One",
      description: "The Genèsis One Role",
      current_state: :initialising
    }

    [role_plain_map: role_plain_map, role1_plain_map: role1_plain_map, role: role, role1: role1]
  end

  test "start_role without params starts a new role with defaults" do
    assert {:ok, pid, new_role} = TrixtaRoles.start_role()

    assert TrixtaRoles.RoleServer.role_pid(new_role.id) == pid
    assert new_role.id != nil
    assert new_role.name =~ ~r/^[a-z]+-[a-z]+-[0-9]+/
    assert new_role.description =~ ~r/.+/
    assert new_role.current_state == :initialising
  end

  test "start_role starts a new role with given state plain map", %{
    role_plain_map: role_plain_map
  } do
    assert {:ok, pid, new_role} = TrixtaRoles.start_role(role_plain_map)

    assert TrixtaRoles.RoleServer.role_pid(new_role.id) == pid
    assert new_role.id != nil
    assert new_role.id == role_plain_map["id"]
    assert new_role.name == "Genèsis Plain"
    assert new_role.description == "The Genèsis Plain Role"
    assert new_role.current_state == :initialising
  end

  test "start_role starts a new role with given state struct", %{role: role} do
    assert {:ok, pid, new_role} = TrixtaRoles.start_role(role)

    assert TrixtaRoles.RoleServer.role_pid(new_role.id) == pid
    assert new_role.id != nil
    assert new_role.id == role.id
    assert new_role.name == "Genèsis"
    assert new_role.description == "The Genèsis Role"
    assert new_role.current_state == :initialising
  end

  test "start_role without an ID starts a new role with given state plain map and autogenerated ID",
       %{
         role1_plain_map: role1_plain_map
       } do
    assert {:ok, pid, new_role} = TrixtaRoles.start_role(role1_plain_map)

    assert TrixtaRoles.RoleServer.role_pid(new_role.id) == pid
    assert new_role.id != nil
    assert new_role.name == "Genèsis One Plain"
    assert new_role.description == "The Genèsis One Plain Role"
    assert new_role.current_state == :initialising
  end

  test "start_role without an ID starts a new role with given state struct and autogenerated ID",
       %{
         role1: role1
       } do
    assert {:ok, pid, new_role} = TrixtaRoles.start_role(role1)

    assert TrixtaRoles.RoleServer.role_pid(new_role.id) == pid
    assert new_role.id != nil
    assert new_role.name == "Genèsis One"
    assert new_role.description == "The Genèsis One Role"
    assert new_role.current_state == :initialising
  end

  test "stop_role stops a given role", %{role: role} do
    assert {:ok, pid, role} = TrixtaRoles.start_role(role)
    assert TrixtaRoles.stop_role(role.id) == :ok
    assert TrixtaRoles.RoleServer.role_pid(role.id) == nil
  end

  test "terminate_role terminates a named role", %{role: role} do
    assert {:ok, pid, role} = TrixtaRoles.start_role(role)
    assert TrixtaRoles.terminate_role(role.id) == :ok
    assert TrixtaRoles.RoleServer.role_pid(role.id) == nil
  end
end
